# Copyright 2018 - 2019 Virtru Corporation
#
# SPDX - License - Identifier: MIT
#

# sample encrypt/decrypt
import sys
from virtru_tdf3_python import Client, Policy, EncryptFileParams, EncryptStringParams, LogLevel

# encrypt the file and apply the policy on tdf file and also decrypt.
try:
    # Create a client
    # TODO: Put your owner email and appId values here
    # client = Client(owner = "<owner-email-id>",
    #                 app_id = "<appid-token>")
    client.enable_console_logging(log_level=LogLevel.Error)

    # Create a simple policy that expires in 60 minutes
    policy = Policy()

    # TODO: Add any users if you would like to share the files with.
    # policy.share_with_users(["user1@example.com", "user2@example.com"])

    policy.expire_in_mins(mins = 60)
    #print(policy)

    #################################################
    # File API
    ################################################

    # Create the encryption parameters
    file_params = EncryptFileParams(in_file_path="sample.docx",
                                    out_file_path="sample.docx.html")

    # Create a default policy
    file_params.set_policy(policy)

    # Use the client and param info to encrypt the file
    policy_id = client.encrypt_file(encrypt_file_params=file_params)
    print("Policy uuid:%s" % (policy_id))

    # Use the client to decrypt the file
    client.decrypt_file(in_file_path="sample.docx.html",
                        out_file_path="sample_py.docx")

    #################################################
    # String API
    ################################################
    # Create the encryption parameters
    plain_text = "Hello world!!"
    string_params = EncryptStringParams(plain_text)

    # share with users
    #string_params.share_with_users(["user1@example.com", "user2@example.com"])

    # Use the client and param info to encrypt the file
    (policy_id, tdf_data) = client.encrypt_string(encrypt_string_params=string_params)
    print("Policy uuid:%s" % (policy_id))

    # Use the client to decrypt the tdf
    decrpy_plain_text = client.decrypt_string(tdf_data)

    if plain_text == decrpy_plain_text:
        print("TDF Encrypt/Decrypt is successful!!")
    else:
        print("Error: TDF Encrypt/Decrypt failed!!")

except:
    print("Unexpected error: %s" % sys.exc_info()[0])
    raise